/*******************************************************************************
 * Copyright 2012 Danny Kunz
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ******************************************************************************/
package org.omnaest.utils.table;

import org.omnaest.utils.operation.special.OperationVoid;

/**
 * A {@link TableExecution} prepares an execution which operates on the {@link ImmutableTable} passed to the
 * {@link #execute(ImmutableTable)} method
 * 
 * @author Omnaest
 * @param <T>
 * @param <E>
 */
public interface TableExecution<T extends ImmutableTable<E>, E> extends OperationVoid<T>
{
  /**
   * Executes providing the locked {@link ImmutableTable} instance
   */
  @Override
  public void execute( T table );
}
